;
;		      Test File for 6502 Cross-Assembler
;
; This file contains all of the 6502 CPU's opcodes in numerical order,
; followed by various tests.

ABS	EQU	$1234
IMM	EQU	$56
IND	EQU	$0078
ZP	EQU	$0090

;
; $00 - $0F
;
	BRK
	ORA	(IND, X)
	ORA	ZP
	ASL	ZP
	PHP
	ORA	#IMM
	ASL	A
	ORA	ABS
	ASL	ABS
;
; $10 - $1F
;
	BPL	*
	ORA	(IND), Y
	ORA	ZP, X
	ASL	ZP, X
	CLC
	ORA	ABS, Y
	ORA	ABS, X
	ASL	ABS, X
;
; $20 - $2F
;
	JSR	ABS
	AND	(IND, X)
	BIT	ZP
	AND	ZP
	ROL	ZP
	PLP
	AND	#IMM
	ROL	A
	BIT	ABS
	AND	ABS
	ROL	ABS
;
; $30 - $3F
;
	BMI	*
	AND	(IND), Y
	AND	ZP, X
	ROL	ZP, X
	SEC
	AND	ABS, Y
	AND	ABS, X
	ROL	ABS, X
;
; $40 - $4F
;
	RTI
	EOR	(IND, X)
	EOR	ZP
	LSR	ZP
	PHA
	EOR	#IMM
	LSR	A
	JMP	ABS
	EOR	ABS
	LSR	ABS
;
; $50 - $5F
;
	BVC	*
	EOR	(IND), Y
	EOR	ZP, X
	LSR	ZP, X
	CLI
	EOR	ABS, Y
	EOR	ABS, X
	LSR	ABS, X
;
; $60 - $6F
;
	RTS
	ADC	(IND, X)
	ADC	ZP
	ROR	ZP
	PLA
	ADC	#IMM
	ROR	A
	JMP	(IND)
	ADC	ABS
	ROR	ABS
;
; $70 - $7F
;
	BVS	*
	ADC	(IND), Y
	ADC	ZP, X
	ROR	ZP, X
	SEI
	ADC	ABS, Y
	ADC	ABS, X
	ROR	ABS, X
;
; $80 - $8F
;
	STA	(IND, X)
	STY	ZP
	STA	ZP
	STX	ZP
	DEY
	TXA
	STY	ABS
	STA	ABS
	STX	ABS
;
; $90 - $9F
;
	BCC	*
	STA	(IND), Y
	STY	ZP, X
	STA	ZP, X
	STX	ZP, Y
	TYA
	STA	ABS, Y
	TXS
	STA	ABS, X
;
; $A0 - $AF
;
	LDY	#IMM
	LDA	(IND, X)
	LDX	#IMM
	LDY	ZP
	LDA	ZP
	LDX	ZP
	TAY
	LDA	#IMM
	TAX
	LDY	ABS
	LDA	ABS
	LDX	ABS
;
; $B0 - $BF
;
	BCS	*
	LDA	(IND), Y
	LDY	ZP, X
	LDA	ZP, X
	LDX	ZP, Y
	CLV
	LDA	ABS, Y
	TSX
	LDY	ABS, X
	LDA	ABS, X
	LDX	ABS, Y
;
; $C0 - $CF
;
	CPY	#IMM
	CMP	(IND, X)
	CPY	ZP
	CMP	ZP
	DEC	ZP
	INY
	CMP	#IMM
	DEX
	CPY	ABS
	CMP	ABS
	DEC	ABS
;
; $D0 - $DF
;
	BNE	*
	CMP	(IND), Y
	CMP	ZP, X
	DEC	ZP, X
	CLD
	CMP	ABS, Y
	CMP	ABS, X
	DEC	ABS, X
;
; $E0 - $EF
;
	CPX	#IMM
	SBC	(IND, X)
	CPX	ZP
	SBC	ZP
	INC	ZP
	INX
	SBC	#IMM
	NOP
	CPX	ABS
	SBC	ABS
	INC	ABS
;
; $F0 - $FF
;
	BEQ	*
	SBC	(IND), Y
	SBC	ZP, X
	INC	ZP, X
	SED
	SBC	ABS, Y
	SBC	ABS, X
	INC	ABS, X
 
; test lables to strip colon

hit:	EQU	*

; test pseudo ops

	DB	12, 24, 46H
	DB	12, "hi there", 34
	BYTE	1,2,3
	DW	12, 24H
	WORD	1, 2
	TEXT	"here is"
	FCC	"more"
	RMB	10
	BLK	5
	DS	2

; test numerics

	DB	$AA, 28, @377, %11100111
	;should add these
	DB	0AAH, 27D, 377Q, 10101100B

; test JMP (nnFF) error

	JMP	(bound)	;jump relative address $6C at page boundary
				;will be read from nnFFH, nn00H
	JMP	(bound-2)	;not at page boundary

; test forced absolute mode versus inequality

ALP	EQU	2 >  4
BTA	EQU	4 <> 2
GMA	EQU	4 >< 2
DTA	EQU	> 2		;side effects: not illegal
	DB	>2		;DB ignores to-absolute
	DW	>2		;DW redundant to-absolute

	ORA	ZP, X		;page zero for byte value
	ASL	ZP, X
	ORA	ZP
	ASL	ZP

	ORA	>ZP, X	;force absolute addr despite byte value
	ASL	>ZP, X
	ORA	>ZP
	ASL	>ZP

	ORA	>ABS		;redundant, should be no error
	ASL	>ABS, X

	STX	>ZP,Y		;these should be illegal or flagged
	STY	>ZP,X		;but simply processed as zero-page
	STX	ABS,Y		;these must be illegal and are so!
	STY	ABS,X

;ASL LSR ROL ROR tests for no-arg versus A arg

	ASL
	ASL	A
	LSR
	LSR	A
	ROL
	ROL	A
	ROR
	ROR	A

	org	01FFH

bound: RMB 2

	end

